#!/bin/sh
#2345678901234567890123456789012345678901234567890123456789012345678901234567890
#
# usage: awk -v synclrdataPath=<path> -v compressed=<0 or 1>
#            -f mobile-docstores.awk 
#
################################################################################

BEGIN { 
	FS = ","
	uncompress = compressed ? "uncompress" : ""
	startQuery = "select \"%s\" docStoreId, d.docId docId, %s(bc.value) value " \
		"from documents d, bodyContent bc " \
		"where d.docId in ( \n" \
		"\"%s\"\n"
	endQuery = ") and d.slotName = \"main\" and "\
		"d.bodyContentHash = bc.bodyContentHash;"
	nDocumentIds = 0}

NR == 1 {
	for (i = 1; i <= NF; i++) col [$i] = i}

NR > 1 {
	if (curDocStoreId != $(col ["docStoreId"])) {
		curDocStoreId = $(col ["docStoreId"])
		if (NR > 2) print endQuery
		printf ".open \"%s/%s.docstore\"\n", synclrdataPath, curDocStoreId
		print ".mode csv" 
		printf ".headers %s\n", (NR == 2) ? "on" : "off"
		printf startQuery, curDocStoreId, uncompress, $(col ["docId"])
		nDocIds = 1}
	else {
		if (nDocIds >= 50) {
			print endQuery
			print ".headers off"
			printf startQuery, curDocStoreId, uncompress, $(col ["docId"])
			nDocIds = 1}
		else {
			printf ", \"%s\"\n", $(col ["docId"])
			nDocIds = nDocIds + 1}}}

END {
	if (NR > 1) print endQuery}			
