@echo off
::345678901234567890123456789012345678901234567890123456789012345678901234567890
::
:: usage: refresh-any-comment.bat pluginDir tempDir catalogPath synclrdataPath
::          compressed
:: 
:: Causes LR to exit gracefully. Then runs the SQLite scripts in "pluginDir" to
:: extract the comments and likes data from the Lightroom catalog "catalogPath"
:: and LR Mobile sync data "synclrdataPath", putting the results into "tempDir".
:: "compressed" is 1 if the comments are compressed in the mobile-docstores
:: database, 0 otherwise. Finally, restarts Lightroom to open "catalogPath".
:: 
::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

set pluginDir=%1
set tempDir=%2
set catalogPath=%3
set synclrdataPath=%4
set compressed=%5

    :: Debugging log
set log=NUL
::set log=%HOMEDRIVE%%HOMEPATH%\Desktop\anycomment.log
type nul: > %log%
cd >> %log%
echo %USERDOMAIN%\%USERNAME% >> %log%
echo %pluginDir% >> %log%

wmic process where "name='lightroom.exe'" get ExecutablePath /FORMAT:table ^
    | %pluginDir%\awk "NR==2 {print $0}" > %tempDir%\lrpath.txt
set /p lrPath=<%tempDir%\lrpath.txt

set maxSleep=25000
for /l %%s in (0, 250, %maxSleep%) do (
    echo sleep %%s >> %log%
    tasklist | find /c /i "lightroom.exe" > nul 2>&1
    if errorlevel 1 goto loop1exit
    if %%s == %maxSleep% (
        echo Failed to stop Lightroom
        tasklist /v >> %log%
        goto exit1)
    cscript sleep250.vbs > NUL)
:loop1exit

%pluginDir%\sqlite3 %catalogPath% < %pluginDir%\publish-comments.sql ^
	> %tempDir%\publish-comments.csv 
    if errorlevel 1 echo sqlite3 (1) failed "(%errorlevel%)"
%pluginDir%\sqlite3 %catalogPath% < %pluginDir%\publish-likes.sql ^
	> %tempDir%\publish-likes.csv 
    if errorlevel 1 echo sqlite3 (2) failed "(%errorlevel%)"

%pluginDir%\sqlite3 %catalogPath% < %pluginDir%\mobile-comments.cat.sql ^
	> %tempDir%\mobile-comments.cat.csv 
    if errorlevel 1 echo sqlite3 (3) failed "(%errorlevel%)"

%pluginDir%\awk -v synclrdataPath=%synclrdataPath% -v compressed=%compressed% ^
    -f %pluginDir%\mobile-docstores.awk ^
	%tempDir%\mobile-comments.cat.csv > %tempDir%\mobile-comments.doc.sql 
    if errorlevel 1 echo awk failed "(%errorlevel%)"
%pluginDir%\sqlite3 < %tempDir%\mobile-comments.doc.sql ^
    > %tempDir%\mobile-comments.doc.csv 
    if errorlevel 1 echo sqlite3 (4) failed "(%errorlevel%)"

:exit1
echo start "%lrPath%" %catalogPath% >> %log%
start "%lrPath%" %catalogPath% 
echo Done >> %log%
